<?php
    header("Access-Control-Allow-Origin: *");
    error_reporting(E_ALL ^ E_NOTICE);
    $docPath    =   "/home/icareuvjtech/public_html/108locations/api";

    require_once($docPath."/classes/db-inc.php");
    $dbHost     =   'localhost';	
    $dbName     =   'icareuvj_locations108';
    $dbUname    =   'icareuvj_loct108';
    $dbPass     =   '*+locations108#%';	

    $db         =   new db_mysql($dbHost,$dbUname,$dbPass,$dbName);
    $db->connect();
    $db->select_db();
    //echo "hai";die();
    
    define("ALERT_SUCCESSMSG", "Success");
    define("ALERT_ACTIONFAIL","Sorry. Not able to process the request");
    define("ALERT_NOINPUT", "Missing input values");
    define("ALERT_NOISERVICE", "Sorry, no service available at your location. Please call 108. Thank you.");
    define("ALERT_NORECORDS", "No records found");
    
    define("SALTIV","1a2b3c4d5e6f7g8i");
    define("SALTKEY","!*&@#^%$1a2b3c4d");
    
    define("PATIENT_LOC_TB","tkt_patient_location");
    define("PATIENT_MONI_TB","tkt_patient_monitor");
    define("SERVICE_LOC_TB","tkt_service_locations");
    
    define("SUBMIT_DATE",date("Y-m-d H:i:s"));
    
    $jsonVal	=	stripslashes(html_entity_decode($_REQUEST['data']));
    //echo $jsonVal;
    $jsonData	=	json_decode(trim($jsonVal), true);
    
    /* Code for managin patient location share */
    if($jsonData['action'] == 'manage_location')
    {
        $resultArr  =   array();
        $validDevice=   0;
        
        $phone      =   trim($jsonData['phone']);
        $uname      =   trim($jsonData['uname']);
        $uemail     =   trim($jsonData['uemail']);
        $latVal     =   trim($jsonData['lat']);
        $lngVal     =   trim($jsonData['lng']);
        
        if($phone != "" && $latVal != "" && $latVal != "0" && $lngVal != "" && $lngVal != "0")
        {
            $contactNumber =   str_replace("'","",str_replace('"','',saltDecode($phone,'string')));
                       
            $addrInfo   =   array();
            $addrInfo   =   getAddress($latVal,$lngVal);
            
            //echo "<pre>";print_r($addrInfo);echo "</pre>";

            $addressLocation =   "";
            if($addrInfo['premise'] != "")
            {
                $addressLocation .=   $addrInfo['premise'].",";
            }
            if($addrInfo['street'] != "")
            {
                $addressLocation .=   $addrInfo['street'].",";
            }
            if($addrInfo['city'] != "")
            {
                $addressLocation .=   $addrInfo['city'].",";
            }
            if($addrInfo['district'] != "")
            {
                $addressLocation .=   $addrInfo['district'].",";
            }
            if($addrInfo['state'] != "")
            {
                $addressLocation .=   $addrInfo['state'].",";
            }
            if($addrInfo['postcode'] != "")
            {
                $addressLocation .=   $addrInfo['postcode'].",";
            }
            if($addrInfo['country'] != "")
            {
                $addressLocation .=   $addrInfo['country'];
            }
            
            $sql_insloc =   "INSERT INTO ".PATIENT_LOC_TB." ( "
                                        . "number, uname, uemail, "
                                        . "city, district, state, address, "
                                        . "lat, lng, created_on, status "
                                        . ") VALUES ("
                                        . "'".$contactNumber."', '".$uname."', '".$uemail."', "
                                        . "'".$addrInfo['city']."', '".$addrInfo['district']."', '".$addrInfo['state']."', '".$addressLocation."', "
                                        . " '".$latVal."', '".$lngVal."', '".SUBMIT_DATE."', 1)";
            $sql_insloc =   $db->query($sql_insloc);
            if($sql_insloc)
            {
                $resultArrNew['is_success'] =   1;
                $resultArrNew['message']    =   ALERT_SUCCESSMSG;
                //$resultArrNew['result']   =   $resultArr;
            }
            else
            {
                $resultArrNew['is_success'] =   0;
                $resultArrNew['message']    =   ALERT_ACTIONFAIL;
                //$resultArrNew['result']   =   $resultArr;
            }
        }
        else
        {
            $resultArrNew['is_success'] =   0;
            $resultArrNew['message']    =   ALERT_NOINPUT;
            //$resultArrNew['result']   =   $resultArr;
        }
        echo json_encode($resultArrNew, true);
    }
    
    /* Code for monitor patient location info */
    if($jsonData['action'] == 'monitor_location')
    {
        $resultArr  =   array();
        $validDevice=   0;
        
        $phone      =   trim($jsonData['phone']);
        $latVal     =   trim($jsonData['lat']);
        $lngVal     =   trim($jsonData['lng']);
        $submit_date=   trim($jsonData['submit_date']);
        
        if($phone != "" && $latVal != "" && $latVal != "0" && $lngVal != "" && $lngVal != "0")
        {
            $contactNumber =   str_replace("'","",str_replace('"','',saltDecode($phone,'string')));
            
            
            $sql_insloc =   "INSERT INTO ".PATIENT_MONI_TB." ( "
                                        . "number, lat, lng, submit_date "
                                        . ") VALUES ("
                                        ." '".$contactNumber."', '".$latVal."', '".$lngVal."', '".$submit_date."')";
            $sql_insloc =   $db->query($sql_insloc);
            if($sql_insloc)
            {
                $resultArrNew['is_success'] =   1;
                $resultArrNew['message']    =   ALERT_SUCCESSMSG;
                //$resultArrNew['result']   =   $resultArr;
            }
            else
            {
                $resultArrNew['is_success'] =   0;
                $resultArrNew['message']    =   ALERT_ACTIONFAIL;
                //$resultArrNew['result']   =   $resultArr;
            }
        }
        else
        {
            $resultArrNew['is_success'] =   0;
            $resultArrNew['message']    =   ALERT_NOINPUT;
            //$resultArrNew['result']   =   $resultArr;
        }
        echo json_encode($resultArrNew, true);
    }
    
    /* Code to get patient location info */    
    if($jsonData['action'] == 'get_requests')
    {
        $distVal    =   $jsonData['district'];
        $stateVal   =   $jsonData['state'];
        
        if($distVal != "" && $stateVal != "")
        {
            //$sql_getsrvcinfo    =   "SELECT * FROM ".SERVICE_LOC_TB." WHERE district = '".$distVal."' AND state = '".$stateVal."'";
            $sql_getsrvcinfo    =   "SELECT * FROM ".SERVICE_LOC_TB." WHERE state = '".$stateVal."'";
            $res_getsrvcinfo    =   mysql_query($sql_getsrvcinfo);
            if(mysql_num_rows($res_getsrvcinfo) > 0)
            {
                $slNo       =   1;
                $actCnt     =   0;
                $incCnt     =   0;
                $actData    =   "";
                $incData    =   "";
                $dateVal    =   date("Y-m-d")." 00:00:00";

                /*$sql_getAloc    =   "SELECT * FROM           ".PATIENT_LOC_TB." "
                                                . "WHERE    district = '".$distVal."' "
                                                . "AND      state = '".$stateVal."' "
                                                . "AND      created_on >= '".$dateVal."' "
                                                . "AND      status = 1 "
                                                . "ORDER BY created_on ASC";*/

                $sql_getAloc    =   "SELECT * FROM           ".PATIENT_LOC_TB." "
                                                . "WHERE    state = '".$stateVal."' "
                                                /*. "AND      created_on >= '".$dateVal."' "*/
                                                . "AND      status = 1 "
                                                . "ORDER BY created_on ASC";//echo $sql_getAloc;die();
                $res_getAloc    =   mysql_query($sql_getAloc);

                $locData    =   '<ul CLASS="patient_loc">';
                if(mysql_num_rows($res_getAloc) > 0)
                {
                    $actCnt     =   1;
                    while($row_getAloc =   mysql_fetch_array($res_getAloc))
                    {
                        if($row_getAloc['uname'] != "")
                        {
                            $user_name  =   " - ".$row_getAloc['uname'];
                        }
                        else
                        {
                            $user_name  =   "";
                        }
                        $actData    .=   '<li class="active" id="'.$row_getAloc['location_id'].'">
                                            <DIV CLASS="loc_container">
                                                <DIV CLASS="loc_top">
                                                    <DIV CLASS="loc_serial">'.$slNo.'</DIV>
                                                    <DIV CLASS="loc_uinfo">
                                                        <DIV CLASS="loc_number">'.$row_getAloc['number'].$user_name.'</DIV> 
                                                        <DIV CLASS="loc_address">'.$row_getAloc['address'].'</DIV>
                                                    </DIV>
                                                    <DIV CLASS="loc_close" id="close_'.$row_getAloc['location_id'].'">
                                                        <A href="javascript:void(0);" onclick="markLocation(\''.$row_getAloc['location_id'].'\');">
                                                            <img src="./images/add-btn.png" width="20" height="20">
                                                        </A>
                                                    </DIV>
                                                </DIV>
                                                
                                            </DIV>
                                        </li>';
                        $slNo++;
                    }
                }


                $sql_getIloc    =   "SELECT * FROM           ".PATIENT_LOC_TB." "
                                                . "WHERE    district = '".$distVal."' "
                                                . "AND      state = '".$stateVal."' "
                                                . "AND      created_on >= '".$dateVal."' "
                                                . "AND      status = 0 "
                                                . "ORDER BY created_on DESC";//echo $sql_getIloc;die();
                $res_getIloc    =   mysql_query($sql_getIloc);
                if(mysql_num_rows($res_getIloc) > 0)
                {
                    $incCnt =   1;
                    while($row_getIloc =   mysql_fetch_array($res_getIloc))
                    {
                        /*$incData    .=   '<li class="inactive" id="'.$row_getIloc['location_id'].'">
                                                <DIV CLASS="loc_container">
                                                    <DIV CLASS="loc_top">
                                                        <DIV CLASS="loc_serial">'.$slNo.'</DIV>
                                                        <DIV CLASS="loc_number">'.$row_getIloc['number'].'</DIV>
                                                    </DIV>
                                                    <DIV CLASS="loc_address">'.$row_getIloc['address'].'</DIV>
                                                </DIV>
                                            </li>';
                        $slNo++;*/
                    }
                }
                $locData    .=  $actData;
                $locData    .=  $incData;
                $locData    .=  '</ul>';

                if($actCnt == 0 && $incCnt == 0)
                {
                    echo "<ul CLASS='patient_loc'>
                            <li class='active' id='1'>
                                <DIV CLASS='loc_container'>
                                    <DIV CLASS='loc_top'>
                                        <DIV CLASS='loc_serial'></DIV>
                                        <DIV CLASS='loc_number'>".ALERT_NORECORDS."</DIV>                            
                                        <DIV CLASS='loc_close' id='close_1'></DIV>
                                    </DIV>
                                </DIV>
                            </li>
                            </ul>"; 
                }
                else
                {
                    echo $locData;
                }
            }
            else
            {
                echo "<ul CLASS='patient_loc'>
                        <li class='active' id='1'>
                            <DIV CLASS='loc_container'>
                                <DIV CLASS='loc_top'>
                                    <DIV CLASS='loc_serial'></DIV>
                                    <DIV CLASS='loc_number'>".ALERT_NOISERVICE."</DIV>                            
                                    <DIV CLASS='loc_close' id='close_1'></DIV>
                                </DIV>
                            </DIV>
                        </li>
                        </ul>"; 
            }
        }
        else
        {
            echo "<ul CLASS='patient_loc'>
                    <li class='active' id='1'>
                        <DIV CLASS='loc_container'>
                            <DIV CLASS='loc_top'>
                                <DIV CLASS='loc_serial'></DIV>
                                <DIV CLASS='loc_number'>".ALERT_NOINPUT."</DIV>                            
                                <DIV CLASS='loc_close' id='close_1'></DIV>
                            </DIV>
                        </DIV>
                    </li>
                    </ul>";
        }
    }
    
    /* Code for removing request  */
    if($jsonData['action'] == 'remove_location')
    {
        $loc_id   =   $jsonData['loc_id'];
        
        if($loc_id > 0)
        {
            $sql_remloc    =   "UPDATE ".PATIENT_LOC_TB." SET status = 0 WHERE location_id = ".$loc_id;
            $res_remloc    =   mysql_query($sql_remloc);
        }
        else
        {
            echo "<ul CLASS='patient_loc'>
                    <li class='active' id='1'>
                        <DIV CLASS='loc_container'>
                            <DIV CLASS='loc_top'>
                                <DIV CLASS='loc_serial'></DIV>
                                <DIV CLASS='loc_number'>".ALERT_NOINPUT."</DIV>                            
                                <DIV CLASS='loc_close' id='close_1'></DIV>
                            </DIV>
                        </DIV>
                    </li>
                    </ul>";
        }
    }
    
    /* Code for removing request  */
    if($jsonData['action'] == 'mark_location')
    {
        $loc_id   =   $jsonData['loc_id'];
        
        if($loc_id > 0)
        {
            $sql_remloc    =   "UPDATE ".PATIENT_LOC_TB." SET status = 2 WHERE location_id = ".$loc_id;
            $res_remloc    =   mysql_query($sql_remloc);
            if($res_remloc)
            {
                $sql_getAloc    =   "SELECT * FROM ".PATIENT_LOC_TB." WHERE location_id = ".$loc_id;
                $res_getAloc    =   mysql_query($sql_getAloc);

                $row_getAloc    =   mysql_fetch_array($res_getAloc);
                $streetInfo     =   array();
                $streetInfo     =   explode(",",$row_getAloc['address']);
                $addressInfo    =   substr(str_replace($streetInfo[0], "", $row_getAloc['address']), 1);
                $url    =   "add.php?street=".urlencode($streetInfo[0])."&city=".$row_getAloc['city']."&address=".urlencode($addressInfo)."&phone=".urlencode($row_getAloc['number'])."&uname=".urlencode($row_getAloc['uname']);
                echo $url;
            }
        }
        else
        {
            echo "<ul CLASS='patient_loc'>
                    <li class='active' id='1'>
                        <DIV CLASS='loc_container'>
                            <DIV CLASS='loc_top'>
                                <DIV CLASS='loc_serial'></DIV>
                                <DIV CLASS='loc_number'>".ALERT_NOINPUT."</DIV>                            
                                <DIV CLASS='loc_close' id='close_1'></DIV>
                            </DIV>
                        </DIV>
                    </li>
                    </ul>";
        }
    }
    
    /* Code for checking appid status */
    if($jsonData['action'] == 'validate_appid')
    {
        if(trim($jsonData['app_id']) != "")
        {
            $app_key    =   saltDecode(trim($jsonData['app_id']), 'string', 0);
            $unit_id    =   trim($jsonData['unit_id']);
            
            $sql_getUser    =   "SELECT * FROM ".RESPONDER_LOGIN_TB." WHERE login_appid = '".$app_key."'";
            $res_getUser    =   $db->query($sql_getUser);

            if($db->num_rows($res_getUser))
            {
                $row_getUser    =   $db->fetch_array($res_getUser);
                
                if($row_getUser['responder_id'] == $unit_id)
                {
                    if($row_getUser['logout_date'] == '0000-00-00 00:00:00' && $row_getUser['logout_status'] == 0 && $row_getUser['login_expire_date'] >= SUBMIT_DATE)
                    {
                        $keyItem    =   1;
                    }
                    else
                    {
                        $keyItem    =   0;
                    }
                    $resultArrNew['is_success']     =   1;
                    $resultArrNew['appid_status']   =   $keyItem;
                    $resultArrNew['message']        =   ALERT_SUCCESSMSG;
                }
                else
                {
                    $resultArrNew['is_success']     =   0;
                    $resultArrNew['appid_status']   =   0;
                    $resultArrNew['message']        =   ALERT_NOUSER;
                }
            }
            else
            {
                $resultArrNew['is_success']     =   0;
                $resultArrNew['appid_status']   =   0;
                $resultArrNew['message']        =   ALERT_NORECORDS;
            }
        }
        else
        {
            $resultArrNew['is_success']     =   0;
            $resultArrNew['appid_status']   =   0;
            $resultArrNew['message']        =   ALERT_NOINPUT;
        }
        echo json_encode($resultArrNew, true);
    }
    
    
    /* Function to generate salt encrypted key */
    function saltEncode($appID)
    {        
        $str        =   $isBinary ? $appID : utf8_decode($appID);
        $td         =   mcrypt_module_open('rijndael-128', ' ', 'cbc', SALTIV);        
        mcrypt_generic_init($td, SALTKEY, SALTIV);        
        $encrypted  =   mcrypt_generic($td, $str);
        mcrypt_generic_deinit($td);
        mcrypt_module_close($td);
        
        return $isBinary ? $encrypted : bin2hex($encrypted);
    }
        
    /* Function to generate salt decrypted key */
    function saltDecode($saltKey, $type, $offmod = '0')
    {
        global $db;
        $code   =   $isBinary ? $saltKey : hexa2bina($saltKey);
        $td     =   mcrypt_module_open('rijndael-128', ' ', 'cbc', SALTIV);
        mcrypt_generic_init($td, SALTKEY, SALTIV);
        $decrypted= mdecrypt_generic($td, $code);
        mcrypt_generic_deinit($td);
        mcrypt_module_close($td);
        
        if($type == 'string')
        {
            $app_key    =   $isBinary ? trim($decrypted) : utf8_encode(trim($decrypted));
            $keyItem    =   $app_key;
        }
        else
        {
            $keyItem        =   0;
        }        
        //return $isBinary ? trim($decrypted) : utf8_encode(trim($decrypted));
        return $keyItem;
        
    }
    
    /* Function to convert data from hex to binary */
    function hexa2bina($hexdata)
    {
        $bindata    =   '';
        for ($i = 0; $i < strlen($hexdata); $i += 2) {
            $bindata .= chr(hexdec(substr($hexdata, $i, 2)));
        }
        return $bindata;
    }
    
    /* Function to generate random key */
    function randomPassword()
    {
        $alphabet   =   "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ0123456789";
        $pass       =   array(); //remember to declare $pass as an array
        $alphaLength=   strlen($alphabet) - 1; //put the length -1 in cache
        for ($i = 0; $i < 8; $i++) 
        {
            $n = rand(0, $alphaLength);
            $pass[] = $alphabet[$n];
        }
        return implode($pass); //turn the array into a string
    }
    
    /* Function to generate login key */
    function loginKey()
    {
        $alphabet   =   "ABCDEFGHIJKLMNOPQRSTUWXYZ";
        $pass       =   array(); //remember to declare $pass as an array
        $alphaLength=   strlen($alphabet) - 1; //put the length -1 in cache
        for ($i = 0; $i < 4; $i++) 
        {
            $n = rand(0, $alphaLength);
            $pass[] = $alphabet[$n];
        }
        return implode($pass); //turn the array into a string
    }
        
    /* Function to generate OTP expire time */
    function getOTPExpTime()
    {
        if (function_exists('date_default_timezone_set'))
        {
          //date_default_timezone_set('Asia/Kolkata');
        }
        $timeArray  =   array();
        $timeArray['submitTime']    =   SUBMIT_DATE;
        $timeArray['expireTime']    =   date("Y-m-d H:i:s",strtotime($timeArray['submitTime']." +10 hours"));
        return $timeArray;
    }
    
    /* Function to get the driving ditance */
    function GetDrivingDistance($lat1, $lat2, $long1, $long2)
    {
        $url    =   "https://maps.googleapis.com/maps/api/distancematrix/json";
        $url    .=   "?origins=".$lat1.",".$long1."&destinations=".$lat2.",".$long2."&mode=driving&language=pl-PL";
        //echo "<br><br>".$url;
        $ch     =   curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_PROXYPORT, 3128);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        $response=  curl_exec($ch);
        curl_close($ch);
        $response_a = json_decode($response, true);
        $dist   =   $response_a['rows'][0]['elements'][0]['distance']['text'];
        $time   =   $response_a['rows'][0]['elements'][0]['duration']['text'];

        return array('distance' => $dist, 'time' => $time);
    }
    
    function formatDate($submit_time,$current_time)
    {
        $date_a     =   new DateTime($submit_time);
        $date_b     =   new DateTime($current_time);
        $date_c     =   new DateTime(SUBMIT_DATE);
    
        $interval   =   date_diff($date_b,$date_c);
        $intervalValue =   $interval->format('%h : %i : %s');
       //echo "Interval - ".$intervalValue."<br><br>";
                
        $intervalHour   =   $interval->format('%h');
        $intervalMinute =   $interval->format('%i');
        $intervalSecond =   $interval->format('%s');
        //date_add($date_c,$intervalValue);
        
        $actionType =   $interval->format('%R');
        /*if($date_c > $date_b)
        {   $actionType =   "+";    }
        else
        {   $actionType =   "-";    }*/
        $date_a->modify($actionType.$intervalHour.' hours');
        $date_a->modify($actionType.$intervalMinute.' minutes');
        $date_a->modify($actionType.$intervalSecond.' seconds');
        
        return $date_a->format("Y-m-d H:i:s");
    }
    
    function getAddress($address_latitude,$address_longitude)
    {
        $addressInfo    =   array();
        
        $geocode	=   file_get_contents('http://maps.google.com/maps/api/geocode/json?latlng='.$address_latitude.','.$address_longitude);
        //$geocode	=   file_get_contents('http://maps.google.com/maps/api/geocode/json?latlng=10.003809,76.342744');

        $output         =   json_decode($geocode);
        //echo "<pre>";print_r($output);echo "</pre>";
        
        $addressInfo['premise'] =   "";
        $addressInfo['street']  =   "";
        $addressInfo['city']    =   "";
        $addressInfo['district']=   "";
        $addressInfo['state']   =   "";
        $addressInfo['postcode']=   "";
        
        $addrComponents =   $output->results[0]->address_components;
        for($p = 0; $p < 10; $p++)
        {
            if($addrComponents[$p]->types[0] == 'premise')
            {
                $addressInfo['premise'] =   $addrComponents[$p]->long_name;
                break;
            }
        }
        for($r = 0; $r < 10; $r++)
        {
            if($addrComponents[$r]->types[0] == 'route')
            {
                $addressInfo['street'] =   $addrComponents[$r]->long_name;
                break;
            }
        }
        for($c = 0; $c < 10; $c++)
        {
            if($addrComponents[$c]->types[0] == 'locality')
            {
                $addressInfo['city'] =   $addrComponents[$c]->long_name;
                break;
            }
        }
        for($d = 0; $d < 10; $d++)
        {
            if($addrComponents[$d]->types[0] == 'administrative_area_level_2')
            {
                $addressInfo['district'] =   $addrComponents[$d]->long_name;
                break;
            }
        }
        for($s = 0; $s < 10; $s++)
        {
            if($addrComponents[$s]->types[0] == 'administrative_area_level_1')
            {
                $addressInfo['state'] =   $addrComponents[$s]->long_name;
                break;
            }
        }
        for($pc = 0; $pc < 10; $pc++)
        {
            if($addrComponents[$pc]->types[0] == 'postal_code')
            {
                $addressInfo['postcode'] =   $addrComponents[$pc]->long_name;
                break;
            }
        }
        for($cn = 0; $cn < 10; $cn++)
        {
            if($addrComponents[$cn]->types[0] == 'country')
            {
                $addressInfo['country'] =   $addrComponents[$cn]->short_name;
                break;
            }
        }
        //echo "<pre>";print_r($addressInfo);echo "</pre>";die();
        return $addressInfo;
    }
?>